Attribute VB_Name = "mMIDI"
Option Explicit

'-------------------------------------
'--> DirectDraw Engine
'--> by Peter "Pro-XeX" Petrov
'--> KenamicK Entertainment 1998-2001

'--> last modified by ...
'-------------------------------------

Public Declare Function mciSendString Lib "winmm.dll" Alias "mciSendStringA" (ByVal lpstrCommand As String, ByVal lpstrReturnString As String, ByVal uReturnLength As Long, ByVal hwndCallback As Long) As Long

Public Function LoadMidi(lpFileName As String, chAlias As String) As Boolean
  Dim rval As Long
  
  rval = mciSendString("open " & lpFileName & _
                       " type sequencer alias " & chAlias, _
                       0, 0, 0)
  If rval <> 0 Then                         ' check for return value
     LoadMidi = False
  Else
     LoadMidi = True
  End If
End Function

Public Function PlayMidi(chAlias As String, Optional bFromStart As Boolean = True) As Boolean
 Dim rval As Long
 
 If bFromStart = True Then
    rval = mciSendString("Play " & chAlias & " from 0", 0, 0, 0)
 Else
    rval = mciSendString("Play " & chAlias & " notify", 0, 0, 0)
 End If
 
  If rval <> 0 Then                         ' check for return value
     PlayMidi = False
  Else
     PlayMidi = True
  End If

End Function

Public Sub PauseMidi(chAlias As String)
 Dim rval As Long
 
 rval = mciSendString("stop " & chAlias, 0, 0, 0)
End Sub

Public Function CloseMidi(chAlias As String) As Boolean
 Dim rval As Long
 
 rval = mciSendString("close " & chAlias, 0, 0, 0)
  
  If rval <> 0 Then                         ' check for return value
     CloseMidi = False
  Else
     CloseMidi = True
  End If
End Function

Public Sub CloseAllMidi()
 Dim rval As Long
 
 rval = mciSendString("close all", 0, 0, 0)
End Sub

