Attribute VB_Name = "mMain"
Option Explicit

Rem ***************************************************************************
Rem * KenamicK Entertainment Engine 01_VB_DirectX7                            *
Rem * core by Peter "Pro-XeX" Petrov                                          *
Rem * used for the game 'Desktop Defender 2'                                  *
Rem * web site: http://www.kenamick.com/                                      *
Rem *                                                                         *
Rem * last modified by: Peter Petorv                          on: ??.03.2004  *
Rem *                                                                         *
Rem * last modified by: ...                                                   *
Rem ***************************************************************************


Public bRunning     As Boolean
Private gfxKartinka As typeGFX_HBM          ' obekt kartinka
Public sndZwuk      As stSoundBuffer        ' obekt zwuk

Sub Main()


 bRunning = True
 
 ' open log file
 Call mUtil.OpenLog(App.Path)
 ' init DX
 Call mDirectDraw.DXInit
 ' init DirectDraw
 Call mDirectDraw.DDInit(frmMain.hwnd, 800, 600, 16, True)
 ' init DirectSound
 Call mDirectSound.DSInit(frmMain.hwnd)
 ' init DirectInput
 Call mDirectInput.DIInit(frmMain.hwnd, DI_KEYBOARD)
 

 ' show form
 frmMain.Show
  
 Do While (bRunning)

    ' ... 
  
    DoEvents
    mDirectDraw.DDBlitToPrim
 Loop
 
 ' close 
 Call ReleaseAll

End Sub


Public Sub _
MakeError(lpStr As String)
  Call MsgBox(lpStr, vbExclamation, "What the...")
  Call ReleaseAll
End Sub


Public Sub _
ErrorMsg(lpStr As String)
 Call MsgBox(lpStr, vbCritical)
End Sub


Public Sub ReleaseAll()
 On Local Error Resume Next
 
 AppendToLog (LOG_DASH)
 AppendToLog ("Unloading ...")

 AppendToLog ("Closing DirectX")
 ' restore graphics mode
 Call DDRestoreModes(frmMain.hwnd)
 
 Call DDRelease
 Call DSRelease
 Call DIRelease
 Call DXRelease

 Call CloseLog
 
 End
 
End Sub


